#!/usr/bin/python

'''

Changelog
****************
v1: July 2013
Initial release

'''

import sys, subprocess


__author__ = """Minas Gjoka"""


if __name__ == "__main__":
    
    run_case = 'test'
    #run_case = 'slashdot'
    
    if run_case == 'test' :        
        # 'test' uses generated graph networkx.generators.powerlaw_cluster_graph with N=1000
        
        #### 1. Sampling and Calculation
        graph_name     = "test" 
        sample_size    = '50'       # number of sampled egonets
        sample_type    = 'uis'   
        replacement    = 'wout'   # with or wout
        labeling       = '1'        # 0 or 1
        attribute_name = 'test.attributes'  # included in the package
        subprocess.call(['./SampleEgonets_CalculateCliques.py', \
                         graph_name,\
                         sample_size,\
                         sample_type,\
                         replacement,\
                         labeling,\
                         attribute_name
                     ])

        #### 2. Estimation
        clique_calculation_pickle = 'test_sample_calculation.pickle'
        output = 'test_clique_estimation.pickle'
        subprocess.call(['./EstimateCliques.py', clique_calculation_pickle, output])        
        
        
    elif run_case == 'slashdot':
        # 'slashdot' topology can be downloaded at http://www.minasgjoka.com/CliqueEstimation
        
        #### 1. Sampling and Calculation
        graph_name     = "soc-Slashdot0811.edges.gz" 
        sample_size    = '1000'       # number of sampled egonets
        sample_type    = 'uis'   
        replacement    = 'with'   # with or wout
        labeling       = '1'        # 0 or 1
        attribute_name = 'none'
        subprocess.call(['./SampleEgonets_CalculateCliques.py', \
                         graph_name,\
                         sample_size,\
                         sample_type,\
                         replacement,\
                         labeling,\
                         attribute_name
                     ])

        #### 2. Estimation
        clique_calculation_pickle = 'soc-Slashdot0811.edges.gz_sample_calculation.pickle'
        output = 'slashdot_clique_estimation.pickle'
        subprocess.call(['./EstimateCliques.py', clique_calculation_pickle, output])             
    